unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Spin, PdfiumCore, LCLIntf, Math;

type

  { TForm1 }

  TForm1 = class(TForm)
    bOpen: TButton;
    Label2: TLabel;
    bNext: TButton;
    Memo1: TMemo;
    odPDF: TOpenDialog;
    Panel3: TPanel;
    bPrev: TButton;
    sePageNo: TSpinEdit;
    bClose: TButton;
    procedure bCloseClick(Sender: TObject);
    procedure bNextClick(Sender: TObject);
    procedure bOpenClick(Sender: TObject);
    procedure bPrevClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sePageNoChange(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

var
  fPDF: TPDFDocument;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PDFiumDllDir := ExtractFilePath(Application.ExeName);
  Memo1.Lines.Clear;
end;

procedure TForm1.bPrevClick(Sender: TObject);
begin
  if sePageNo.Value > sePageNo.MinValue then
    sePageNo.Value := sePageNo.Value - 1;
end;

procedure TForm1.bNextClick(Sender: TObject);
begin
  if sePageNo.Value < sePageNo.MaxValue then
    sePageNo.Value := sePageNo.Value + 1;
end;

procedure TForm1.bCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.bOpenClick(Sender: TObject);
begin
  if not odPDF.Execute then
    exit;
  if fPDF <> nil then
  begin
    fPDF.Close;
    FreeAndNil(fPDF);
  end;
  fPDF := TPDFDocument.Create;
  fPDF.LoadFromFile(odPDF.FileName);
  Caption := odPDF.FileName;
  sepageNo.Value := 1;
  sePageNo.MinValue := 1;
  sePageNo.MaxValue := fPDF.PageCount;
  sePageNo.Enabled := fPDF.PageCount > 1;
  bPrev.Enabled := fPDF.PageCount > 1;
  bNext.Enabled := fPDF.PageCount > 1;
  sePageNoChange(Sender);
end;

procedure TForm1.sePageNoChange(Sender: TObject);
begin
  Memo1.Lines.Text := fPDF.Pages[sePageNo.Value - 1].ReadText(0, fPDF.Pages[sePageNo.Value - 1].GetCharCount);
end;

end.

